=== debian/changelog ===
gammaray (2.0.1-1ubuntu1) trusty; urgency=medium

  * Fix build failure with GraphViz >= 2.36.0.
    - Add graphviz-2.36.0.patch, cherry-picked from upstream.

 -- Felix Geyer <debfx@ubuntu.com>  Tue, 18 Mar 2014 17:16:13 +0100

gammaray (2.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Refreshed d/patches/use-empty-rpath.patch.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Wed, 05 Mar 2014 19:28:40 +0100

gammaray (2.0.0-1) unstable; urgency=low

  * New upstream release.
  * Refreshed d/patches/use-empty-rpath.patch.
  * Removed no longer needed patches:
    - widget-export-actions-location.patch
    - harfbuzz-search-path.patch
    - find-widget-export-actions-when-attaching.patch
    - gammaray-probe-versioned-soname.patch.
  * Use xz for orig tarball compression.
  * Bump Standards-Version to 3.9.5.
  * Enable build of Qt5 GUI and Qt5 + Qt4 probe libraries.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Tue, 21 Jan 2014 22:03:14 +0100

gammaray (1.3.0-1) experimental; urgency=low

  * New upstream release.
  * Add dependency on VTK 5.10 and enable object visualizer plugin.
  * Don't set RPATH in binaries; prevents binary-or-shlib-defines-rpath
    lintian error.
  * Refreshed d/patches/widget-export-actions-location.patch and
    d/patches/gammaray-probe-versioned-soname.patch.
  * Enable KJob tracker plugin.
  * Updated d/copyright.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Mon, 04 Feb 2013 22:54:36 +0100
