=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install override_dh_installdocs override_dh_strip override_dh_clean

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

%:
	dh $@ --parallel

override_dh_auto_configure:
	# Move away bundled Qt private headers so that system versions are used
	if [ -d 3rdparty/qt/private ]; then \
		mv 3rdparty/qt/private 3rdparty/qt/private.dont.use; \
	fi

	dh_auto_configure -B obj-qt5
	dh_auto_configure -B obj-qt4 -- -DGAMMARAY_ENFORCE_QT4_BUILD=ON -DGAMMARAY_PROBE_ONLY_BUILD=ON

override_dh_auto_build:
	dh_auto_build -B obj-qt5 -O--parallel
	dh_auto_build -B obj-qt4 -O--parallel

override_dh_auto_test:
	xvfb-run dh_auto_test

override_dh_auto_install:
	dh_auto_install -B obj-qt5
	dh_auto_install -B obj-qt4
	rm -f debian/tmp/usr/share/doc/gammaray/License.txt

override_dh_installdocs:
	dh_installdocs --link-doc=gammaray

override_dh_strip:
	dh_strip --dbg-package=gammaray-dbg

override_dh_clean:
	dh_clean

	# Put back bundled Qt private headers to restore sources into original state
	if [ -d 3rdparty/qt/private.dont.use ]; then \
		mv 3rdparty/qt/private.dont.use 3rdparty/qt/private; \
	fi
